diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wimax/helper/wimax-helper.cc ns-3.31/src/wimax/helper/wimax-helper.cc
--- ns-3.30.1/src/wimax/helper/wimax-helper.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wimax/helper/wimax-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -510,14 +510,32 @@
 
       EnableAsciiForConnection (theStream, nodeid, deviceid, (char*) "WimaxNetDevice", (char*) "InitialRangingConnection");
       EnableAsciiForConnection (theStream, nodeid, deviceid, (char*) "WimaxNetDevice", (char*) "BroadcastConnection");
-      EnableAsciiForConnection (theStream, nodeid, deviceid, (char*) "SubscriberStationNetDevice", (char*) "BasicConnection");
-      EnableAsciiForConnection (theStream, nodeid, deviceid, (char*) "SubscriberStationNetDevice", (char*) "PrimaryConnection");
+
+      // The following connections can not be made right away because the BasicConnection and the PrimaryConnection are created later.
+      // We defer the creation to the SubscriberStationNetDevice
+
+      // EnableAsciiForConnection (theStream, nodeid, deviceid, (char*) "SubscriberStationNetDevice", (char*) "BasicConnection");
+      // EnableAsciiForConnection (theStream, nodeid, deviceid, (char*) "SubscriberStationNetDevice", (char*) "PrimaryConnection");
+
+      Ptr<SubscriberStationNetDevice> ssNetDev = DynamicCast<SubscriberStationNetDevice> (nd);
+      if (ssNetDev)
+        {
+          SubscriberStationNetDevice::AsciiTraceCallback EnqueueCb = MakeBoundCallback (&AsciiTraceHelper::DefaultEnqueueSinkWithContext, theStream);
+          ssNetDev->SetAsciiTxQueueEnqueueCallback (EnqueueCb);
+
+          SubscriberStationNetDevice::AsciiTraceCallback DequeueCb = MakeBoundCallback (&AsciiTraceHelper::DefaultDequeueSinkWithContext, theStream);
+          ssNetDev->SetAsciiTxQueueDequeueCallback (DequeueCb);
+
+          SubscriberStationNetDevice::AsciiTraceCallback DropCb = MakeBoundCallback (&AsciiTraceHelper::DefaultDropSinkWithContext, theStream);
+          ssNetDev->SetAsciiTxQueueDropCallback (DropCb);
+        }
+
       return;
     }
 
   //
   // If we are provided an OutputStreamWrapper, we are expected to use it, and
-  // to providd a context.  We are free to come up with our own context if we
+  // to provide a context.  We are free to come up with our own context if we
   // want, and use the AsciiTraceHelper Hook*WithContext functions, but for
   // compatibility and simplicity, we just use Config::Connect and let it deal
   // with the context.
@@ -540,9 +558,25 @@
 
   EnableAsciiForConnection (stream, nodeid, deviceid, (char*) "WimaxNetDevice", (char*) "InitialRangingConnection");
   EnableAsciiForConnection (stream, nodeid, deviceid, (char*) "WimaxNetDevice", (char*) "BroadcastConnection");
-  EnableAsciiForConnection (stream, nodeid, deviceid, (char*) "SubscriberStationNetDevice", (char*) "BasicConnection");
-  EnableAsciiForConnection (stream, nodeid, deviceid, (char*) "SubscriberStationNetDevice", (char*) "PrimaryConnection");
 
+  // The following connections can not be made right away because the BasicConnection and the PrimaryConnection are created later.
+  // We defer the creation to the SubscriberStationNetDevice
+
+  // EnableAsciiForConnection (stream, nodeid, deviceid, (char*) "SubscriberStationNetDevice", (char*) "BasicConnection");
+  // EnableAsciiForConnection (stream, nodeid, deviceid, (char*) "SubscriberStationNetDevice", (char*) "PrimaryConnection");
+
+  Ptr<SubscriberStationNetDevice> ssNetDev = DynamicCast<SubscriberStationNetDevice> (nd);
+  if (ssNetDev)
+    {
+      SubscriberStationNetDevice::AsciiTraceCallback EnqueueCb = MakeBoundCallback (&AsciiTraceHelper::DefaultEnqueueSinkWithContext, stream);
+      ssNetDev->SetAsciiTxQueueEnqueueCallback (EnqueueCb);
+
+      SubscriberStationNetDevice::AsciiTraceCallback DequeueCb = MakeBoundCallback (&AsciiTraceHelper::DefaultDequeueSinkWithContext, stream);
+      ssNetDev->SetAsciiTxQueueDequeueCallback (DequeueCb);
+
+      SubscriberStationNetDevice::AsciiTraceCallback DropCb = MakeBoundCallback (&AsciiTraceHelper::DefaultDropSinkWithContext, stream);
+      ssNetDev->SetAsciiTxQueueDropCallback (DropCb);
+    }
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wimax/model/bandwidth-manager.cc ns-3.31/src/wimax/model/bandwidth-manager.cc
--- ns-3.30.1/src/wimax/model/bandwidth-manager.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wimax/model/bandwidth-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -222,10 +222,10 @@
   uint32_t allocationPerFrame = 0;
 
   std::vector<SSRecord*> *ssRecords = bs->GetSSManager ()->GetSSRecords ();
-  for (std::vector<SSRecord*>::iterator iter1 = ssRecords->begin (); iter1 != ssRecords->end (); ++iter1)
+  for (std::vector<SSRecord*>::const_iterator iter1 = ssRecords->begin (); iter1 != ssRecords->end (); ++iter1)
     {
-      for (std::vector<ServiceFlow*>::iterator iter2 = (*iter1)->GetServiceFlows (ServiceFlow::SF_TYPE_ALL).begin ();
-           iter2 != (*iter1)->GetServiceFlows (ServiceFlow::SF_TYPE_ALL).end (); ++iter2)
+      std::vector<ServiceFlow*> ssServiceFlows = (*iter1)->GetServiceFlows (ServiceFlow::SF_TYPE_ALL);
+      for (std::vector<ServiceFlow*>::const_iterator iter2 = ssServiceFlows.begin (); iter2 != ssServiceFlows.end (); ++iter2)
         {
           allocationPerFrame += (*iter2)->GetRecord ()->GetGrantSize ();
         }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wimax/model/ss-net-device.cc ns-3.31/src/wimax/model/ss-net-device.cc
--- ns-3.30.1/src/wimax/model/ss-net-device.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wimax/model/ss-net-device.cc	2020-06-27 17:38:30.000000000 -0700
@@ -22,6 +22,7 @@
 
 #include "ns3/simulator.h"
 #include "ns3/node.h"
+#include "ns3/config.h"
 #include "ss-net-device.h"
 #include "wimax-phy.h"
 #include "ns3/packet-burst.h"
@@ -279,6 +280,10 @@
 
   m_linkManager = 0;
 
+  m_asciiTxQueueEnqueueCb.Nullify ();
+  m_asciiTxQueueDequeueCb.Nullify ();
+  m_asciiTxQueueDropCb.Nullify ();
+
   WimaxNetDevice::DoDispose ();
 }
 
@@ -430,6 +435,27 @@
 SubscriberStationNetDevice::SetBasicConnection (Ptr<WimaxConnection> basicConnection)
 {
   m_basicConnection = basicConnection;
+  uint32_t nodeId = GetNode ()->GetId ();
+  uint32_t ifaceId = GetIfIndex ();
+
+  if (!m_asciiTxQueueEnqueueCb.IsNull ())
+    {
+      std::ostringstream oss;
+      oss << "/NodeList/" << nodeId << "/DeviceList/" << ifaceId << "/$ns3::SubscriberStationNetDevice/BasicConnection/TxQueue/Enqueue";
+      Config::Connect (oss.str (), m_asciiTxQueueEnqueueCb);
+    }
+  if (!m_asciiTxQueueDequeueCb.IsNull ())
+    {
+      std::ostringstream oss;
+      oss << "/NodeList/" << nodeId << "/DeviceList/" << ifaceId << "/$ns3::SubscriberStationNetDevice/BasicConnection/TxQueue/Dequeue";
+      Config::Connect (oss.str (), m_asciiTxQueueDequeueCb);
+    }
+  if (!m_asciiTxQueueDropCb.IsNull ())
+    {
+      std::ostringstream oss;
+      oss << "/NodeList/" << nodeId << "/DeviceList/" << ifaceId << "/$ns3::SubscriberStationNetDevice/BasicConnection/TxQueue/Drop";
+      Config::Connect (oss.str (), m_asciiTxQueueDropCb);
+    }
 }
 
 Ptr<WimaxConnection>
@@ -442,6 +468,28 @@
 SubscriberStationNetDevice::SetPrimaryConnection (Ptr<WimaxConnection> primaryConnection)
 {
   m_primaryConnection = primaryConnection;
+
+  uint32_t nodeId = GetNode ()->GetId ();
+  uint32_t ifaceId = GetIfIndex ();
+
+  if (!m_asciiTxQueueEnqueueCb.IsNull ())
+    {
+      std::ostringstream oss;
+      oss << "/NodeList/" << nodeId << "/DeviceList/" << ifaceId << "/$ns3::SubscriberStationNetDevice/PrimaryConnection/TxQueue/Enqueue";
+      Config::Connect (oss.str (), m_asciiTxQueueEnqueueCb);
+    }
+  if (!m_asciiTxQueueDequeueCb.IsNull ())
+    {
+      std::ostringstream oss;
+      oss << "/NodeList/" << nodeId << "/DeviceList/" << ifaceId << "/$ns3::SubscriberStationNetDevice/PrimaryConnection/TxQueue/Dequeue";
+      Config::Connect (oss.str (), m_asciiTxQueueDequeueCb);
+    }
+  if (!m_asciiTxQueueDropCb.IsNull ())
+    {
+      std::ostringstream oss;
+      oss << "/NodeList/" << nodeId << "/DeviceList/" << ifaceId << "/$ns3::SubscriberStationNetDevice/PrimaryConnection/TxQueue/Drop";
+      Config::Connect (oss.str (), m_asciiTxQueueDropCb);
+    }
 }
 
 Ptr<WimaxConnection>
@@ -1283,4 +1331,22 @@
   event = eventId;
 }
 
+void
+SubscriberStationNetDevice::SetAsciiTxQueueEnqueueCallback (AsciiTraceCallback cb)
+{
+  m_asciiTxQueueEnqueueCb = cb;
+}
+
+void
+SubscriberStationNetDevice::SetAsciiTxQueueDequeueCallback (AsciiTraceCallback cb)
+{
+  m_asciiTxQueueDequeueCb = cb;
+}
+
+void
+SubscriberStationNetDevice::SetAsciiTxQueueDropCallback (AsciiTraceCallback cb)
+{
+  m_asciiTxQueueDropCb = cb;
+}
+
 } // namespace ns`
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wimax/model/ss-net-device.h ns-3.31/src/wimax/model/ss-net-device.h
--- ns-3.30.1/src/wimax/model/ss-net-device.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wimax/model/ss-net-device.h	2020-06-27 17:38:30.000000000 -0700
@@ -342,6 +342,27 @@
    */
   void SetServiceFlowManager (Ptr<SsServiceFlowManager> sfm);
 
+  /// Callback for logging packets on ASCII traces
+  typedef Callback<void, std::string, Ptr<const Packet> > AsciiTraceCallback;
+
+  /**
+   * Set the Enqueue callback for ASCII tracing
+   * \param cb callback for ASCII tracing
+   */
+  void SetAsciiTxQueueEnqueueCallback (AsciiTraceCallback cb);
+
+  /**
+   * Set the Dequeue callback for ASCII tracing
+   * \param cb callback for ASCII tracing
+   */
+  void SetAsciiTxQueueDequeueCallback (AsciiTraceCallback cb);
+
+  /**
+   * Set the Drop callback for ASCII tracing
+   * \param cb callback for ASCII tracing
+   */
+  void SetAsciiTxQueueDropCallback (AsciiTraceCallback cb);
+
 private:
   /**
    * Get default lost DL map interval
@@ -483,6 +504,13 @@
    * \see class CallBackTraceSource
    */
   TracedCallback<Ptr<const Packet> > m_ssRxDropTrace;
+
+  /// Bound callback to perform ASCII logging for Enqueue events
+  AsciiTraceCallback m_asciiTxQueueEnqueueCb;
+  /// Bound callback to perform ASCII logging for Dequeue events
+  AsciiTraceCallback m_asciiTxQueueDequeueCb;
+  /// Bound callback to perform ASCII logging for Drop events
+  AsciiTraceCallback m_asciiTxQueueDropCb;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wimax/model/wimax-tlv.cc ns-3.31/src/wimax/model/wimax-tlv.cc
--- ns-3.30.1/src/wimax/model/wimax-tlv.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wimax/model/wimax-tlv.cc	2020-06-27 17:38:30.000000000 -0700
@@ -890,7 +890,7 @@
 uint32_t
 PortRangeTlvValue::GetSerializedSize (void) const
 {
-  return m_portRange->size () * sizeof(struct PortRange);
+  return m_portRange->size () * 4; // a port range is defined by 2 ports, each using 2 bytes
 }
 void
 PortRangeTlvValue::Serialize (Buffer::Iterator i) const
@@ -1037,7 +1037,7 @@
 uint32_t
 Ipv4AddressTlvValue::GetSerializedSize (void) const
 {
-  return m_ipv4Addr->size () * sizeof(struct ipv4Addr);
+  return m_ipv4Addr->size () * 8; // IPv4 address and mask are 4 bytes each
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wimax/wscript ns-3.31/src/wimax/wscript
--- ns-3.30.1/src/wimax/wscript	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wimax/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -64,6 +64,12 @@
             'test/wimax-fragmentation-test.cc',
         ]
 
+    # Tests encapsulating example programs should be listed here
+    if (bld.env['ENABLE_EXAMPLES']):
+        obj_test.source.extend([
+        #   'test/wimax-examples-test-suite.cc',
+            ])
+    
     headers = bld(features='ns3header')
     headers.module = 'wimax'
     headers.source = [
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wscript ns-3.31/src/wscript
--- ns-3.30.1/src/wscript	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -192,10 +192,6 @@
                       Warning, stacklevel=2)
         return
 
-    if ("ns3-%s" % (module,)) not in env.NS3_ENABLED_MODULES:
-        #print "bindings for module %s which is not enabled, skip" % module
-        return
-
     env.append_value('PYTHON_MODULES_BUILT', module)
     try:
         apidefs = env['PYTHON_BINDINGS_APIDEFS'].replace("-", "_")
@@ -253,14 +249,21 @@
     bindgen.env['FEATURES'] = ','.join(features)
     bindgen.dep_vars = ['FEATURES', "GCC_RTTI_ABI_COMPLETE"]
     bindgen.name = "pybindgen(ns3 module %s)" % module
+    bindgen.module = module
     bindgen.install_path = None
 
+    # Retrieve the module dependencies
+    module_obj = bld.get_tgen_by_name('ns3-' + module)
+    module_deps = module_obj.use.copy()
+    module_deps.append('ns3-' + module)
+
     # generate the extension module
     pymod = bld(features='cxx cxxshlib pyext')
     pymod.source = ['bindings/ns3module.cc']
     pymod.target = '%s/%s' % (module_target_dir, extension_name)
     pymod.name = 'ns3module_%s' % module
-    pymod.use = ["%s" % mod for mod in pymod.env['NS3_ENABLED_MODULES']] #  Should be '"ns3-"+module', but see bug 1117
+    pymod.module= module
+    pymod.use =  module_deps #  Should be '"ns3-"+module', but see bug 1117
     if pymod.env['ENABLE_STATIC_NS3']:
         if sys.platform == 'darwin':
             pymod.env.append_value('LINKFLAGS', '-Wl,-all_load')
@@ -275,6 +278,10 @@
             pymod.env.append_value('LINKFLAGS', '-Wl,-Bdynamic,--no-whole-archive')
     defines = list(pymod.env['DEFINES'])
     defines.extend(['NS_DEPRECATED=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_31=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_30=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_27=', 'NS3_DEPRECATED_H'])
+    defines.extend(['NS_DEPRECATED_3_26=', 'NS3_DEPRECATED_H'])
     if Utils.unversioned_sys_platform()== 'win32':
         try:
             defines.remove('_DEBUG') # causes undefined symbols on win32
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/test.py ns-3.31/test.py
--- ns-3.30.1/test.py	2019-08-12 16:43:20.000000000 -0700
+++ ns-3.31/test.py	2020-06-27 17:38:30.000000000 -0700
@@ -25,10 +25,23 @@
 import signal
 import xml.dom.minidom
 import shutil
-import re
+import fnmatch
 
 from utils import get_list_from_file
 
+# imported from waflib Logs
+colors_lst={'USE':True,'BOLD':'\x1b[01;1m','RED':'\x1b[01;31m','GREEN':'\x1b[32m','YELLOW':'\x1b[33m','PINK':'\x1b[35m','BLUE':'\x1b[01;34m','CYAN':'\x1b[36m','GREY':'\x1b[37m','NORMAL':'\x1b[0m','cursor_on':'\x1b[?25h','cursor_off':'\x1b[?25l',}
+def get_color(cl):
+    if colors_lst['USE']:
+        return colors_lst.get(cl,'')
+    return''
+class color_dict(object):
+    def __getattr__(self,a):
+        return get_color(a)
+    def __call__(self,a):
+        return get_color(a)
+colors=color_dict()
+
 try:
     import queue
 except ImportError:
@@ -90,7 +103,7 @@
 # If the user has constrained us to run certain kinds of tests, we can tell waf
 # to only build
 #
-core_kinds = ["bvt", "core", "performance", "system", "unit"]
+core_kinds = ["core", "performance", "system", "unit"]
 
 #
 # There are some special cases for test suites that kill valgrind.  This is
@@ -604,7 +617,7 @@
         except FileNotFoundError:
             print('The .lock-waf ... directory was not found.  You must do waf build before running test.py.', file=sys.stderr)
             sys.exit(2)
-     
+
     for line in f:
         if line.startswith("top_dir ="):
             key, val = line.split('=')
@@ -1095,7 +1108,6 @@
                 waf_cmd = "./waf --target=%s" % os.path.basename(options.example)
             else:
                 waf_cmd = "./waf --target=%s" % os.path.basename(options.example)
-
         else:
             if sys.platform == "win32": #Modify for windows
                 waf_cmd = "./waf"
@@ -1215,7 +1227,7 @@
     if options.kinds:
         path_cmd = os.path.join("utils", test_runner_name + " --print-test-type-list")
         (rc, standard_out, standard_err, et) = run_job_synchronously(path_cmd, os.getcwd(), False, False)
-        print(standard_out.decode())
+        print(standard_out)
 
     if options.list:
         if len(options.constrain):
@@ -1315,14 +1327,19 @@
         # See if this is a valid test suite.
         path_cmd = os.path.join("utils", test_runner_name + " --print-test-name-list")
         (rc, suites, standard_err, et) = run_job_synchronously(path_cmd, os.getcwd(), False, False)
+
         if isinstance(suites, bytes):
             suites = suites.decode()
-        if options.suite in suites.split('\n'):
-            suites = options.suite + "\n"
-            single_suite = True
-        else:
+
+        suites_found = fnmatch.filter(suites.split('\n'), options.suite)
+
+        if not suites_found:
             print('The test suite was not run because an unknown test suite name was requested.', file=sys.stderr)
             sys.exit(2)
+        elif len(suites_found) == 1:
+            single_suite = True
+
+        suites = '\n'.join(suites_found)
 
     elif len(options.example) == 0 and len(options.pyexample) == 0:
         if len(options.constrain):
@@ -1392,6 +1409,13 @@
             if len(stderr_results) == 0:
                 processors = int(stdout_results)
 
+    if (options.process_limit):
+        if (processors < options.process_limit):
+            print('Using all %s processors' % processors)
+        else:
+            processors = options.process_limit
+            print('Limiting to %s worker processes' % processors)
+
     #
     # Now, spin up one thread per processor which will eventually mean one test
     # per processor running concurrently.
@@ -1536,33 +1560,38 @@
         # match what is done in the wscript file.
         example_name = "%s%s-%s%s" % (APPNAME, VERSION, options.example, BUILD_PROFILE_SUFFIX)
 
-        # Don't try to run this example if it isn't runnable.
-        if example_name not in ns3_runnable_programs_dictionary:
-            print("Example %s is not runnable." % example_name)
+        key_list = []
+        for key in ns3_runnable_programs_dictionary:
+            key_list.append (key)
+        example_name_key_list = fnmatch.filter(key_list, example_name)
+
+        if len(example_name_key_list) == 0:
+            print("No example matching the name %s" % options.example)
         else:
             #
             # If you tell me to run an example, I will try and run the example
             # irrespective of any condition.
             #
-            example_path = ns3_runnable_programs_dictionary[example_name]
-            example_path = os.path.abspath(example_path)
-            job = Job()
-            job.set_is_example(True)
-            job.set_is_pyexample(False)
-            job.set_display_name(example_path)
-            job.set_tmp_file_name("")
-            job.set_cwd(testpy_output_dir)
-            job.set_basedir(os.getcwd())
-            job.set_tempdir(testpy_output_dir)
-            job.set_shell_command(example_path)
-            job.set_build_path(options.buildpath)
+            for example_name_iter in example_name_key_list:
+                example_path = ns3_runnable_programs_dictionary[example_name_iter]
+                example_path = os.path.abspath(example_path)
+                job = Job()
+                job.set_is_example(True)
+                job.set_is_pyexample(False)
+                job.set_display_name(example_path)
+                job.set_tmp_file_name("")
+                job.set_cwd(testpy_output_dir)
+                job.set_basedir(os.getcwd())
+                job.set_tempdir(testpy_output_dir)
+                job.set_shell_command(example_path)
+                job.set_build_path(options.buildpath)
 
-            if options.verbose:
-                print("Queue %s" % example_name)
+                if options.verbose:
+                    print("Queue %s" % example_name_iter)
 
-            input_queue.put(job)
-            jobs = jobs + 1
-            total_tests = total_tests + 1
+                input_queue.put(job)
+                jobs = jobs + 1
+                total_tests = total_tests + 1
 
     #
     # Run some Python examples as smoke tests.  We have a list of all of
@@ -1698,29 +1727,35 @@
 
         if job.is_skip:
             status = "SKIP"
+            status_print = colors.GREY + status + colors.NORMAL
             skipped_tests = skipped_tests + 1
             skipped_testnames.append(job.display_name + (" (%s)" % job.skip_reason))
         else:
             if job.returncode == 0:
                 status = "PASS"
+                status_print = colors.GREEN + status + colors.NORMAL
                 passed_tests = passed_tests + 1
             elif job.returncode == 1:
                 failed_tests = failed_tests + 1
                 failed_testnames.append(job.display_name)
                 status = "FAIL"
+                status_print = colors.RED + status + colors.NORMAL
             elif job.returncode == 2:
                 valgrind_errors = valgrind_errors + 1
                 valgrind_testnames.append(job.display_name)
                 status = "VALGR"
+                status_print = colors.CYAN + status + colors.NORMAL
             else:
                 crashed_tests = crashed_tests + 1
                 crashed_testnames.append(job.display_name)
                 status = "CRASH"
+                status_print = colors.PINK + status + colors.NORMAL
 
+        print("[%d/%d]" % (passed_tests + failed_tests + skipped_tests + crashed_tests, total_tests), end=' ')
         if options.duration or options.constrain == "performance":
-            print("%s (%.3f): %s %s" % (status, job.elapsed_time, kind, job.display_name))
+            print("%s (%.3f): %s %s" % (status_print, job.elapsed_time, kind, job.display_name))
         else:
-            print("%s: %s %s" % (status, kind, job.display_name))
+            print("%s: %s %s" % (status_print, kind, job.display_name))
 
         if job.is_example or job.is_pyexample:
             #
@@ -1980,10 +2015,21 @@
                       metavar="XML-FILE",
                       help="write detailed test results into XML-FILE.xml")
 
+    parser.add_option("--nocolor", action="store_true", dest="nocolor", default=False,
+                      help="do not use colors in the standard output")
+    parser.add_option("--jobs", action="store", type="int", dest="process_limit", default=0,
+                      help="limit number of worker threads")
+
     global options
     options = parser.parse_args()[0]
     signal.signal(signal.SIGINT, sigint_hook)
 
+    # From waf/waflib/Options.py
+    envcolor=os.environ.get('NOCOLOR','') and 'no' or 'auto' or 'yes'
+    
+    if options.nocolor or envcolor == 'no':
+        colors_lst['USE'] = False
+    
     return run_tests()
 
 if __name__ == '__main__':
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/utils/bench-packets.cc ns-3.31/utils/bench-packets.cc
--- ns-3.30.1/utils/bench-packets.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/utils/bench-packets.cc	2020-06-27 17:38:30.000000000 -0700
@@ -363,7 +363,7 @@
   uint32_t minIterations = 1;
   bool enablePrinting = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Usage ("Benchmark Packet class");
   cmd.AddValue ("n", "number of iterations", n);
   cmd.AddValue ("min-iterations", "number of subiterations to minimize iteration time over", minIterations);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/utils/bench-simulator.cc ns-3.31/utils/bench-simulator.cc
--- ns-3.30.1/utils/bench-simulator.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/utils/bench-simulator.cc	2020-06-27 17:38:30.000000000 -0700
@@ -91,7 +91,7 @@
   Ptr<RandomVariableStream> m_rand; ///< random variable
   uint32_t m_population; ///< population
   uint32_t m_total; ///< total
-  uint32_t m_count; ///< count 
+  uint32_t m_count; ///< count
 };
 
 void
@@ -203,17 +203,19 @@
 int main (int argc, char *argv[])
 {
 
-  bool schedCal  = false;
-  bool schedHeap = false;
-  bool schedList = false;
-  bool schedMap  = true;
+  bool schedCal           = false;
+  bool schedHeap          = false;
+  bool schedList          = false;
+  bool schedMap           = true;
+  bool schedPriorityQueue = false;
 
   uint32_t pop   =  100000;
   uint32_t total = 1000000;
   uint32_t runs  =       1;
   std::string filename = "";
+  bool calRev = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.Usage ("Benchmark the simulator scheduler.\n"
              "\n"
              "Event intervals are taken from one of:\n"
@@ -223,9 +225,11 @@
              "In the case of either --file form, the input is expected\n"
              "to be ascii, giving the relative event times in ns.");
   cmd.AddValue ("cal",   "use CalendarSheduler",          schedCal);
+  cmd.AddValue ("calrev", "reverse ordering in the CalendarScheduler", calRev);
   cmd.AddValue ("heap",  "use HeapScheduler",             schedHeap);
   cmd.AddValue ("list",  "use ListSheduler",              schedList);
   cmd.AddValue ("map",   "use MapScheduler (default)",    schedMap);
+  cmd.AddValue ("pri",   "use PriorityQueue",             schedPriorityQueue);
   cmd.AddValue ("debug", "enable debugging output",       g_debug);
   cmd.AddValue ("pop",   "event population size (default 1E5)",         pop);
   cmd.AddValue ("total", "total number of events to run (default 1E6)", total);
@@ -240,6 +244,7 @@
   if (schedCal)
     {
       factory.SetTypeId ("ns3::CalendarScheduler");
+      factory.Set ("Reverse", BooleanValue (calRev));
     }
   if (schedHeap)
     {
@@ -249,12 +254,22 @@
     {
       factory.SetTypeId ("ns3::ListScheduler");
     }
+  if (schedPriorityQueue)
+    {
+      factory.SetTypeId ("ns3::PriorityQueueScheduler");
+    }
+      
   Simulator::SetScheduler (factory);
 
   LOGME (std::setprecision (g_fwidth - 6));
   DEB ("debugging is ON");
 
-  LOGME ("scheduler: " << factory.GetTypeId ().GetName ());
+  std::string order;
+  if (schedCal)
+    {
+      order = ": insertion order: " + std::string (calRev ? "reverse" : "normal");
+    }
+  LOGME ("scheduler: " << factory.GetTypeId ().GetName () << order);
   LOGME ("population: " << pop);
   LOGME ("total events: " << total);
   LOGME ("runs: " << runs);
@@ -265,7 +280,7 @@
   // table header
   LOG ("");
   LOG (std::left << std::setw (g_fwidth) << "Run #" <<
-       std::left << std::setw (3 * g_fwidth) << "Inititialization:" <<
+       std::left << std::setw (3 * g_fwidth) << "Initialization:" <<
        std::left << std::setw (3 * g_fwidth) << "Simulation:");
   LOG (std::left << std::setw (g_fwidth) << "" <<
        std::left << std::setw (g_fwidth) << "Time (s)" <<
